#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "tool_common.h"
#include "devices.h"

int hex_dump( void* base, const char* tag, unsigned int offset, unsigned int len )
{
	int idx;

	for( idx = 0; idx < len; idx++ )
	{
		if( !(idx & 0x7) )
		{
			printf( "%s0x%04X [%s]: ", idx ? "\n" : "", offset + (idx << 2), tag );
		}
		printf( "0x%08X ", *(unsigned int*)(base + offset + (idx << 2)) );
	}

	printf( "\n" );

	return EXIT_SUCCESS;
}

int reg_dump(int fd, void* base, unsigned int module_base, const char* tag, const reg_with_name_t* regs )
{
	const reg_with_name_t* reg;
	unsigned int read_data;

	printf("//---- Dumping %s Registers ---------\n", tag);
	printf("//---- Base Address = 0x%X ---------\n",  module_base);
	printf("Addr      \tData      \tName\n");
	for( reg = regs; reg->name; reg++ )
	{
		read_reg32(fd, base, module_base + reg->addr, &read_data);

		printf( "0x%03X\t0x%08X\t%s\n", reg->addr, read_data, reg->name);
	}

	printf( "\n" );

	return EXIT_SUCCESS;
}
